// Emacs style mode select -*- C++ -*-
//----------------------------------------------------------------------------
//
// Copyright (C) 2013 James Haley et al.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/
//
// Additional terms and conditions compatible with the GPLv3 apply. See the
// file COPYING-EE for details.
//
//----------------------------------------------------------------------------
//
// DESCRIPTION:
//
// Fixed-point support functions for Small
//
//----------------------------------------------------------------------------

#if 0

#include "z_zone.h"

#include "m_fixed.h"
#include "tables.h"

static cell AMX_NATIVE_CALL sm_floattofixed(AMX *amx, cell *params)
{
   return (cell)(amx_ctof(params[1]) * FRACUNIT);
}

static cell AMX_NATIVE_CALL sm_fmul(AMX *amx, cell *params)
{
   return FixedMul(params[1], params[2]);
}

static cell AMX_NATIVE_CALL sm_fdiv(AMX *amx, cell *params)
{
   if(params[2] == 0)
   {
      amx_RaiseError(amx, AMX_ERR_DIVIDE);
      return -1;
   }

   return FixedDiv(params[1], params[2]);
}

static cell AMX_NATIVE_CALL sm_fabs(AMX *amx, cell *params)
{
   return D_abs(params[1]);
}

//
// sm_fsin
//
// Sine function for Small's fixed_t angles.
//
static cell AMX_NATIVE_CALL sm_fsin(AMX *amx, cell *params)
{
   angle_t a = FixedToAngle((fixed_t)params[1]);

   return finesine[a >> ANGLETOFINESHIFT];
}

//
// sm_fcos
//
// Cosine function for Small's fixed_t angles.
//
static cell AMX_NATIVE_CALL sm_fcos(AMX *amx, cell *params)
{
   angle_t a = FixedToAngle((fixed_t)params[1]);

   return finecosine[a >> ANGLETOFINESHIFT];
}

AMX_NATIVE_INFO fixed_Natives[] =
{
   { "_ffloat",         sm_floattofixed },
   { "_fmul",           sm_fmul },
   { "_fdiv",           sm_fdiv },
   { "_fabs",           sm_fabs },
   { "_fsin",           sm_fsin },
   { "_fcos",           sm_fcos },
   { NULL,              NULL }
};
#endif

// EOF

